# This file is a template, and might need editing before it works on your project.
# This is a sample GitLab CI/CD configuration file that should run without any modifications.
# It demonstrates a basic 3 stage CI/CD pipeline. Instead of real tests or scripts,
# it uses echo commands to simulate the pipeline execution.
#
# A pipeline is composed of independent jobs that run scripts, grouped into stages.
# Stages run in sequential order, but jobs within stages run in parallel.
#
# For more information, see: https://docs.gitlab.com/ee/ci/yaml/index.html#stages
#
# You can copy and paste this template into a new `.gitlab-ci.yml` file.
# You should not add this template to an existing `.gitlab-ci.yml` file by using the `include:` keyword.
#
# To contribute improvements to CI/CD templates, please follow the Development guide at:
# https://docs.gitlab.com/ee/development/cicd/templates.html
# This specific template is located at:
# https://gitlab.com/gitlab-org/gitlab/-/blob/master/lib/gitlab/ci/templates/Getting-Started.gitlab-ci.yml

stages:          # Список этапов
  - build
  - test
  - done

.default_rules:
    rules:
    - changes: 
      - nginx/www/index.html

build-job:       # Запуск контейнера
  stage: build
  rules:
    - !reference [.default_rules, rules]
  script:
    - sudo docker-compose up -d

get-test-job:   # HTTP-запрос
  stage: test  
  rules:
    - !reference [.default_rules, rules]  
  script:
      - curl -s -o /dev/null -i -w "%{http_code}" localhost:9889

sum-test-job:   # Проверка md5-суммы index.html
  stage: test    # It can run at the same time as get-test-job (in parallel).
  rules:
    - !reference [.default_rules, rules]
  script:
    - curl localhost:9889 | md5sum > tempfile1
    - cat nginx/www/index.html | md5sum > tempfile2
    - '[[ "$(cat tempfile1)" = "$(cat tempfile2)" ]]'
    - rm tempfile1 tempfile2


done-job:      # Удаление контрейнера
  stage: done  # It only runs when *both* jobs in the test stage complete successfully.
  rules:
    - !reference [.default_rules, rules]
  script:
    - sudo docker-compose down
    - sudo docker rmi nginx
